#ifndef _HAVE_MAIN_H
#define _HAVE_MAIN_H

#include "SDL.h"
#include "SDL_ttf.h"
#include "sound.h"

typedef struct
{
	int up, down, left, right, button1, button2, buttonctrl;
} Controls;

typedef struct
{
	float x, y, speed_x, speed_y, jumppower;
	int ground, animtime, animframe, shooting, shootwait, hurting, hurttime, hearts, score;
	SDL_Rect rect;
	SDL_Rect spriterect;
} Player;

SDL_Surface* screen;
SDL_Surface* fontsurf;
SDL_Surface* sprite_player;
SDL_Surface* sprite_goat;
SDL_Surface* sprite_slime;
SDL_Surface* gfx_brick;
SDL_Surface* gfx_goat_count;
SDL_Surface* gfx_heart;

TTF_Font* font;
Controls controls;
Player player;
Synth* sfx_player_jump;
Synth* sfx_player_scare;
Synth* sfx_player_scare2;
Synth* sfx_clear_goat1;
Synth* sfx_clear_goat2;
Synth* sfx_hurting;
Synth* sfx_c4;
Synth* sfx_f4;

char** level;
int numgoats, activegoats, newlevelpause, nthlevel;
float slimespeedmin, slimespeedmax;
float gravity;
void (*framefn)(int);

int cmod(int a, int b);

#else
#endif
